LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_signed.ALL;
USE ieee.std_logic_arith.ALL;

ENTITY CounterE IS
  PORT (
    Clk12, ClkEn, Reset : IN  std_logic;
    Mode                : OUT std_logic_vector(3 DOWNTO 0)); 
END;

ARCHITECTURE CounterA OF CounterE IS
	signal Mode_s : std_logic_vector(3 downto 0) := "0000";
BEGIN
	Mode <= Mode_s;
	process(CLK12, ClkEn, Reset) is
	begin
		if Reset='0' then
			Mode_s <= "0000";
		elsif ClkEn = '1' and rising_edge(Clk12) then
			Mode_s<= Mode_s + 1;
			
		end if;
	end process;

END;

-- pragma synthesis_off 
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_signed.ALL;
USE ieee.std_logic_arith.ALL;

ENTITY CounterTbE IS
END;

ARCHITECTURE CounterTbA OF CounterTbE IS
  COMPONENT CounterE IS
    PORT (
      Clk12, ClkEn, Reset : IN  std_logic;
      Mode                : OUT std_logic_vector(3 DOWNTO 0)); 
  END COMPONENT;

  SIGNAL Clk12S, ClkEnS, ResetS : std_logic;
  SIGNAL ModeS                  : std_logic_vector(3 DOWNTO 0);
  
BEGIN
  
  CounterL : CounterE
    PORT MAP (Clk12S, ClkEnS, ResetS, ModeS);

-- Takt 
  PROCESS
  BEGIN
    Clk12S <= '0';
    WAIT FOR 41.667 ns;
    Clk12S <= '1';
    WAIT FOR 41.667 ns;
  END PROCESS;

  ResetS <= '0', '1' AFTER 41.667 ns;
  ClkEnS <= '0', '1' AFTER 166.667 ns;
END;

-- pragma synthesis_on
