-- pragma synthesis_off 
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_signed.ALL;
USE ieee.std_logic_arith.ALL;

ENTITY ImConTbE IS
  GENERIC (ClkT : time := 83.33 ns);
END ImConTbE;

ARCHITECTURE ImConTbA OF ImConTbE IS
  
  COMPONENT ImConE IS
    PORT (Button    : IN  std_logic;
           Clk12    : IN  std_logic;
           Reset    : IN  std_logic;
           Mode     : OUT std_logic_vector (3 DOWNTO 0);
           ResetAll : OUT std_logic); 
  END COMPONENT;

  SIGNAL ButtonS, Clk12S, ResetS, ResetAllS : std_logic := '0';
  SIGNAL ModeS                              : std_logic_vector (3 DOWNTO 0);

  SIGNAL stopS : std_logic := '0';

BEGIN
  
  ImConL : ImConE
    PORT MAP (Button    => ButtonS,
               Clk12    => Clk12S,
               Reset    => ResetS,
               Mode     => ModeS,
               ResetAll => ResetAllS);   

-- Takt 
  PROCESS
  BEGIN
    Clk12S <= '0';
    WAIT FOR 41.667 ns;
    Clk12S <= '1';
    WAIT FOR 41.667 ns;
  END PROCESS;

  ResetS <= '0' AFTER 0*ClkT,
            '1' AFTER 0.5*ClkT;
  
  ButtonS <= '1' AFTER 0*ClkT,
             '0' AFTER 2*ClkT,
             '1' AFTER 10*ClkT,
             '0' AFTER 12*ClkT,
             '1' AFTER 15*ClkT,
             '0' AFTER 18*ClkT,
             '1' AFTER 21*ClkT,
             '0' AFTER 24*ClkT,
             '1' AFTER 30*ClkT;
  
  stopS <= '0' AFTER 0*ClkT,
           '1' AFTER 50*ClkT;
--assert now<40*ClkT                            
  ASSERT stopS = '0'
    REPORT "stop simulation"
    SEVERITY failure;

END ImConTbA;

-- pragma synthesis_on
