-- Package fuer gesamtes Projekt
-- Ausgabe eines QVGA-Bilds mit einem VGA-Monitor

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

PACKAGE ImPack IS

  CONSTANT CHBack       : integer := 48;  -- horizontal back porch
  CONSTANT CHData       : integer := 320;       -- pixels per line
  CONSTANT CH2Data      : integer := 640;       -- pixels per line  
  CONSTANT CHFront      : integer := 16;  -- horizontal front porch
  CONSTANT CHSync       : integer := 96;  -- horizontal sync pulse
  CONSTANT CVBack       : integer := 33;  -- vertical back porch
  CONSTANT CVData       : integer := 240;       -- lines per frame
  CONSTANT CV2Data      : integer := 480;       -- lines per frame
  CONSTANT CVFront      : integer := 10;  -- vertical front porch
  CONSTANT CVSync       : integer := 2;   -- vertical sync pulse  
  CONSTANT CWidth       : integer := 12;  -- data width bit
  CONSTANT CDepth       : integer := 17;  -- address width bit -> 2**depth locations
  SUBTYPE  It1024 IS integer RANGE 0 TO 1024;
  SUBTYPE  Itmega IS integer RANGE 0 TO 1048576;
  CONSTANT CNDiv        : integer := 12;  -- Taktteiler
  CONSTANT Limit        : integer := 24000000;  -- Grenze fr langen Tastendruck
  CONSTANT CounterWidth : integer := 32;  -- Wortbreite fr Zhler
END ImPack;




